local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local _

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.InCombat = s.InCombat()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.GCD = s.GlobalCooldown()
	x.Spec = s.Spec()
	a.Flash("dark_intent,if=!aura.spell_power_multiplier.up")
	a.Flash("Pet Attack")
	a.Flash("Pet Assist")
	a.Flash("Banish")
	a.Flash("Create Healthstone", "Create Soulwell")
	a.Flash("Soulshatter")
	a.Flash("Dark Regeneration")
	a.Flash("Burning Rush")
	a.Flash("summon_pet,if=!talent.grimoire_of_sacrifice.enabled|buff.grimoire_of_sacrifice.down", "grimoire_of_sacrifice,if=talent.grimoire_of_sacrifice.enabled")
	a.FlashAll("flask,type=warm_sun", "mogu_fish_stew", "jade_serpent_potion")
--	a.Flash("Unbound Will")
	if x.Spec == 1 then
		-- Affliction
		x.TickSpeed = a.getHastedTickTime(2)
		x.MaxGCD = a.getHastedTickTime(1.5)
		x.UATicks = a.getTotalTicks(7)
		x.UARemains = s.MyDebuffDuration(30108--[[Unstable Affliction]], "target")
		x.UATicksRemain = ceil(x.UARemains / x.TickSpeed)
		x.CorruptionTicks = a.getTotalTicks(9)
		x.CorruptionRemains = s.MyDebuffDuration(172--[[Corruption]], "target")
		x.CorruptionTicksRemain = ceil(x.CorruptionRemains / x.TickSpeed)
		x.AgonyTicks = a.getTotalTicks(12)
		x.AgonyRemains = s.MyDebuffDuration(980--[[Agony]], "target")
		x.AgonyTicksRemain = ceil(x.AgonyRemains / x.TickSpeed)
		if s.HasTalent(108505--[[Archimonde's Darkness]]) then
			local charges, _, _, cooldownDuration = GetSpellCharges(113860--[[Dark Soul: Misery]])
			if charges > 0 then
				x.DarkSoulCD = s.SpellCooldown(113860--[[Dark Soul: Misery]])
			else
				x.DarkSoulCD = s.SpellCooldown(113860--[[Dark Soul: Misery]]) + cooldownDuration
			end
		else
			x.DarkSoulCD = s.SpellCooldown(113860--[[Dark Soul: Misery]])
		end
		x.DarkSoulRemains = s.BuffDuration(113860--[[Dark Soul: Misery]], "player")
		x.SoulShards = s.Power("player", SPELL_POWER_SOUL_SHARDS)
		x.InterruptMaleficGrasp =  not s.Channeling(103103--[[Malefic Grasp]], "player") or x.DarkSoulCD < x.GCD or s.HealthPercent("target") <= 20
		x.IntProc = a.getIntProc()
		x.TrinketIntProcStack = a.getIntProcStacks()
		a.Flash("Curse of Exhaustion")
		a.Flash("curse_of_the_elements,if=debuff.magic_vulnerability.down",
		        "jade_serpent_potion,if=buff.bloodlust.react|target.health.pct<=20",
				"lifeblood",
				"berserking",
				"blood_fury",
		        "Dark Soul: Misery",
				"service_pet,if=talent.grimoire_of_service.enabled",
				"summon_doomguard",
				"soul_swap,cycle_targets=1,if=buff.soulburn.up",
				"soulburn,if=(buff.dark_soul.up|trinket.proc.intellect.react|trinket.stacking_proc.intellect.react>7)&(dot.agony.ticks_remain<=action.agony.add_ticks%2|dot.corruption.ticks_remain<=action.corruption.add_ticks%2|dot.unstable_affliction.ticks_remain<=action.unstable_affliction.add_ticks%2)&shard_react",
				"soulburn,if=(dot.unstable_affliction.ticks_remain<=1|dot.corruption.ticks_remain<=1|dot.agony.ticks_remain<=1)&shard_react&target.health.pct<=20",
				"haunt,if=!in_flight_to_target&remains<cast_time+travel_time+tick_time&shard_react&target.health.pct<=20",
				"soulburn,if=stat.spell_power>dot.unstable_affliction.spell_power&dot.unstable_affliction.ticks_remain<=action.unstable_affliction.add_ticks%2&shard_react&target.health.pct<=20",
				"life_tap,if=buff.dark_soul.down&buff.bloodlust.down&mana.pct<10&target.health.pct<=20",
				"drain_soul,interrupt=1,chain=1,if=target.health.pct<=20",
				"life_tap,if=target.health.pct<=20",
				"agony,cycle_targets=1,if=remains<gcd&remains+2<cooldown.dark_soul.remains&miss_react",
				"haunt,if=!in_flight_to_target&remains<cast_time+travel_time+tick_time&(soul_shard>2|cooldown.dark_soul.remains>35|(soul_shard>1&cooldown.dark_soul.remains<cast_time))&shard_react",
				"corruption,cycle_targets=1,if=remains<gcd&remains<cooldown.dark_soul.remains&miss_react",
				"unstable_affliction,cycle_targets=1,if=remains<gcd+cast_time&remains<cooldown.dark_soul.remains&miss_react",
				"agony,cycle_targets=1,if=ticks_remain<=2&remains+2<cooldown.dark_soul.remains&miss_react",
				"corruption,cycle_targets=1,if=ticks_remain<=2&remains<cooldown.dark_soul.remains&miss_react",
				"unstable_affliction,cycle_targets=1,if=(remains-cast_time)%(duration%current_ticks)<=2&remains<cooldown.dark_soul.remains&miss_react",
				"agony,cycle_targets=1,if=stat.spell_power>spell_power&(!trinket.stacking_proc.intellect.react|trinket.stacking_proc.intellect.react>7)&ticks_remain<add_ticks%2&remains+2<cooldown.dark_soul.remains&miss_react",
				"corruption,cycle_targets=1,if=stat.spell_power>spell_power&(!trinket.stacking_proc.intellect.react|trinket.stacking_proc.intellect.react>7)&ticks_remain<add_ticks%2&remains<cooldown.dark_soul.remains&miss_react",
				"unstable_affliction,cycle_targets=1,if=stat.spell_power>spell_power&(!trinket.stacking_proc.intellect.react|trinket.stacking_proc.intellect.react>7)&ticks_remain<add_ticks%2&remains<cooldown.dark_soul.remains&miss_react",
				"life_tap,if=buff.dark_soul.down&buff.bloodlust.down&mana.pct<50",
				"malefic_grasp,chain=1,interrupt_if=cooldown.dark_soul.remains=0|target.health.pct<=20",
				"life_tap,moving=1,if=mana.pct<80&mana.pct<target.health.pct",
				"fel_flame,moving=1",
				"life_tap")
	elseif x.Spec == 2 then
		-- Demonology
		x.CorruptionSpeed = a.getHastedTickTime(2)
		x.CorruptionTicks = a.getTotalTicks(9)
		x.CorruptionRemains = s.MyDebuffDuration(172--[[Corruption]], "target")
		x.CorruptionTicksRemain = ceil(x.CorruptionRemains / x.CorruptionSpeed)
		x.DoomTicks = a.getTotalTicks(4)
		x.DoomDuration = s.MyDebuffDuration(603--[[Doom]], "target")
		x.DoomTicksRemain = ceil(x.DoomDuration / a.getHastedTickTime(15))
		x.ShadowBoltCastTime = s.CastTime(686--[[Shadow Bolt]])
		x.Metamorphosis = s.Buff(103958--[[Metamorphosis]], "player")
		x.DemonicFury = s.Power("player", SPELL_POWER_DEMONIC_FURY)
		x.DarkSoulRemains = s.BuffDuration(113861--[[Dark Soul: Knowledge]], "player")
		x.SoulFireCondition = x.DarkSoulRemains < x.ShadowBoltCastTime + x.GCD or x.DarkSoulRemains > s.CastTime(6353--[[Soul Fire]]) + x.GCD
		a.Flash("Carrion Swarm")
		a.Flash("Demonic Leap")
		if a.GetConfig("use_530_rotation") then
			x.PerfectAimDuration = s.BuffDuration(138963--[[Perfect Aim]], "player")
			a.Flash("curse_of_the_elements,if=debuff.magic_vulnerability.down",
					"jade_serpent_potion,if=buff.bloodlust.react|target.health.pct<=20",
					"lifeblood",
					"berserking",
					"blood_fury",
					"Dark Soul: Knowledge",
					"service_pet,if=talent.grimoire_of_service.enabled",
					"felguard:felstorm",
					"wrathguard:wrathstorm",
					"summon_doomguard",
--					"metamorphosis,if=buff.perfect_aim.react&active_enemies>1",
					"doom,cycle_targets=1,if=buff.metamorphosis.up&buff.perfect_aim.react&(crit_pct<100|ticks_remain<=add_ticks)",
					"touch_of_chaos,cycle_targets=1,if=buff.metamorphosis.up&dot.corruption.ticking&dot.corruption.remains<1.5",
					"soul_fire,if=buff.metamorphosis.up&buff.molten_core.react&(buff.perfect_aim.react&buff.perfect_aim.remains>cast_time)",
					"doom,cycle_targets=1,if=buff.metamorphosis.up&(ticks_remain<=1|(ticks_remain+1<n_ticks&buff.dark_soul.up))&target.time_to_die>=30&miss_react&dot.doom.crit_pct<100",
					"touch_of_chaos,cycle_targets=1,if=buff.metamorphosis.up&dot.corruption.ticking&dot.corruption.remains<20&dot.corruption.crit_pct<100",
					"cancel_metamorphosis,if=buff.metamorphosis.up&buff.dark_soul.down&demonic_fury<=650&target.time_to_die>30",
					"soul_fire,if=buff.metamorphosis.up&buff.molten_core.react&(buff.dark_soul.remains<action.shadow_bolt.cast_time|buff.dark_soul.remains>cast_time)",
					"touch_of_chaos,if=buff.metamorphosis.up",
					"corruption,cycle_targets=1,if=buff.perfect_aim.react&(crit_pct<100|ticks_remain<=add_ticks)",
					"hand_of_guldan,if=buff.perfect_aim.react&buff.perfect_aim.remains>travel_time",
					"corruption,cycle_targets=1,if=!ticking&target.time_to_die>=6&miss_react",
					"metamorphosis,if=(buff.dark_soul.up&demonic_fury%32>buff.dark_soul.remains)|(dot.corruption.remains<5&dot.corruption.crit_pct<100)|!dot.doom.ticking|demonic_fury>=950|demonic_fury%32>target.time_to_die|buff.perfect_aim.react",
					"hand_of_guldan,if=!in_flight&dot.shadowflame.remains<travel_time+action.shadow_bolt.cast_time&(charges=2|dot.shadowflame.remains>travel_time|(charges=1&recharge_time<4))",
					"soul_fire,if=buff.molten_core.react&(buff.dark_soul.remains<action.shadow_bolt.cast_time|buff.dark_soul.remains>cast_time)",
					"life_tap,if=mana.pct<60",
					"shadow_bolt",
					"fel_flame,moving=1",
					"life_tap")
		elseif x.UVLS then
			x.PerfectAimDuration = s.BuffDuration(138963--[[Perfect Aim]], "player")
			a.Flash("curse_of_the_elements,if=debuff.magic_vulnerability.down",
					"jade_serpent_potion,if=buff.bloodlust.react|target.health.pct<=20",
					"lifeblood",
					"berserking",
					"blood_fury",
					"Dark Soul: Knowledge",
					"service_pet,if=talent.grimoire_of_service.enabled",
					"felguard:felstorm",
					"wrathguard:wrathstorm",
					"summon_doomguard",
	--				"metamorphosis,if=buff.perfect_aim.react&active_enemies>1",
					"doom,cycle_targets=1,if=buff.metamorphosis.up&buff.perfect_aim.react&(crit_pct<100|ticks_remain<=add_ticks)",
					"soul_fire,if=buff.metamorphosis.up&buff.molten_core.react&(buff.perfect_aim.react&buff.perfect_aim.remains>cast_time)",
					"doom,cycle_targets=1,if=buff.metamorphosis.up&(ticks_remain<=1|(ticks_remain+1<n_ticks&buff.dark_soul.up))&target.time_to_die>=30&miss_react&dot.doom.crit_pct<100",
					"cancel_metamorphosis,if=buff.metamorphosis.up&buff.dark_soul.down&demonic_fury<=650&target.time_to_die>30&(cooldown.metamorphosis.remains<4|demonic_fury<=300)&!(action.hand_of_guldan.in_flight&dot.shadowflame.remains)",
					"soul_fire,if=buff.metamorphosis.up&buff.molten_core.react&(buff.dark_soul.remains<action.shadow_bolt.cast_time|buff.dark_soul.remains>cast_time)",
					"touch_of_chaos,if=buff.metamorphosis.up",
					"hand_of_guldan,if=buff.perfect_aim.react&buff.perfect_aim.remains>travel_time",
					"metamorphosis,if=(buff.dark_soul.up&buff.dark_soul.remains<demonic_fury%32)|demonic_fury>=950|demonic_fury%32>target.time_to_die|buff.perfect_aim.react|(action.hand_of_guldan.in_flight&dot.shadowflame.remains)",
					"corruption,cycle_targets=1,if=buff.perfect_aim.react&(crit_pct<100|ticks_remain<=add_ticks)",
					"corruption,cycle_targets=1,if=!ticking&target.time_to_die>=6&miss_react",
					"corruption,cycle_targets=1,if=spell_power<stat.spell_power&ticks_remain<=add_ticks%2&target.time_to_die>=6&miss_react&crit_pct<100",
					"hand_of_guldan,if=!in_flight&dot.shadowflame.remains<travel_time+action.shadow_bolt.cast_time&(charges=2|dot.shadowflame.remains>travel_time|(charges=1&recharge_time<4))",
					"soul_fire,if=buff.molten_core.react&(buff.dark_soul.remains<action.shadow_bolt.cast_time|buff.dark_soul.remains>cast_time)&(buff.molten_core.react>9|target.health.pct<=28)",
					"life_tap,if=mana.pct<60",
					"shadow_bolt",
					"fel_flame,moving=1",
					"life_tap")
		else
			a.Flash("curse_of_the_elements,if=debuff.magic_vulnerability.down",
					"jade_serpent_potion,if=buff.bloodlust.react|target.health.pct<=20",
					"lifeblood",
					"berserking",
					"blood_fury",
					"Dark Soul: Knowledge",
					"service_pet,if=talent.grimoire_of_service.enabled",
					"felguard:felstorm",
					"wrathguard:wrathstorm",
					"summon_doomguard",
					"doom,cycle_targets=1,if=buff.metamorphosis.up&(ticks_remain<=1|(ticks_remain+1<n_ticks&buff.dark_soul.up)|(ticks_remain<=add_ticks%2&stat.spell_power>spell_power))&target.time_to_die>=30&miss_react",
					"cancel_metamorphosis,if=buff.metamorphosis.up&buff.dark_soul.down&demonic_fury<=650&target.time_to_die>30&(cooldown.metamorphosis.remains<4|demonic_fury<=300)&!(action.hand_of_guldan.in_flight&dot.shadowflame.remains)",
					"soul_fire,if=buff.metamorphosis.up&buff.molten_core.react&(buff.dark_soul.remains<action.shadow_bolt.cast_time|buff.dark_soul.remains>cast_time)",
					"touch_of_chaos,if=buff.metamorphosis.up",
					"metamorphosis,if=(buff.dark_soul.up&buff.dark_soul.remains<demonic_fury%32)|demonic_fury>=950|demonic_fury%32>target.time_to_die|(action.hand_of_guldan.in_flight&dot.shadowflame.remains)",
					"corruption,cycle_targets=1,if=!ticking&target.time_to_die>=6&miss_react",
					"corruption,cycle_targets=1,if=spell_power<stat.spell_power&ticks_remain<=add_ticks%2&target.time_to_die>=6&miss_react",
					"hand_of_guldan,if=!in_flight&dot.shadowflame.remains<travel_time+action.shadow_bolt.cast_time&(charges=2|dot.shadowflame.remains>travel_time|(charges=1&recharge_time<4))",
					"soul_fire,if=buff.molten_core.react&(buff.dark_soul.remains<action.shadow_bolt.cast_time|buff.dark_soul.remains>cast_time)&(buff.molten_core.react>9|target.health.pct<=28)",
					"life_tap,if=mana.pct<60",
					"shadow_bolt",
					"fel_flame,moving=1",
					"life_tap")
		end
	elseif x.Spec == 3 then
		-- Destruction
		x.DarkSoulRemains = s.BuffDuration(113858--[[Dark Soul: Instability]], "player")
		x.BurningEmbers = UnitPower("player", SPELL_POWER_BURNING_EMBERS, true) / 10
		x.ImmolateSpeed = a.getHastedTickTime(3)
		x.ImmolateTicks = a.getTotalTicks(5)
		x.ImmolateDuration = s.MyDebuffDuration(348--[[Immolate]], "target")
		x.ImmolateTicksRemain = ceil(x.ImmolateDuration / x.ImmolateSpeed)
		x.ActiveEnemies = a.getNumEnemies()
		x.IntProc = a.getIntProc()
		x.TrinketIntProcStack = a.getIntProcStacks()
		if x.ActiveEnemies < 1 then
			x.ActiveEnemies = 1
		end
		a.Flash("curse_of_the_elements,if=debuff.magic_vulnerability.down",
		        "jade_serpent_potion,if=buff.bloodlust.react|target.health.pct<=20",
		        "lifeblood",
				"berserking",
				"blood_fury",
		        "Dark Soul: Instability",
				"service_pet,if=talent.grimoire_of_service.enabled",
				"summon_doomguard",
				"rain_of_fire,if=!ticking&!in_flight&active_enemies>1",
				"havoc,target=2,if=active_enemies>1",
				"shadowburn,if=ember_react&(burning_ember>3.5|mana.pct<=20|buff.dark_soul.up|target.time_to_die<20|buff.havoc.stack>=1|trinket.proc.intellect.react|(trinket.stacking_proc.intellect.react>7&trinket.stacking_proc.intellect.remains>cast_time))",
				"immolate,cycle_targets=1,if=buff.dark_soul.react&dot.immolate.crit_pct<(stat.crit+30)&ticks_remain<add_ticks%2&miss_react",
				"immolate,cycle_targets=1,if=stat.spell_power>spell_power&ticks_remain<add_ticks%2&miss_react&dot.immolate.crit_pct<(stat.crit+30)",
				"immolate,cycle_targets=1,if=ticks_remain<cast_time&target.time_to_die>=5&miss_react",
				"conflagrate,if=charges=2&buff.havoc.stack=0",
				"rain_of_fire,if=!ticking&!in_flight,moving=1",
				"chaos_bolt,if=ember_react&target.health.pct>20&(buff.backdraft.stack<3|level<86|(active_enemies>1&action.incinerate.cast_time<1))&(burning_ember>(4.5-active_enemies)|buff.dark_soul.remains>cast_time|buff.skull_banner.remains>cast_time|(trinket.proc.intellect.react&trinket.proc.intellect.remains>cast_time)|(trinket.stacking_proc.intellect.react>6&trinket.stacking_proc.intellect.remains>cast_time))",
				"chaos_bolt,if=ember_react&target.health.pct>20&(buff.havoc.stack=3&buff.havoc.remains>cast_time)",
				"conflagrate",
				"incinerate",
				"fel_flame,moving=1")
	end
end)

